#ifndef _IMAGESGI
#define _IMAGESGI

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>

class ImageSGI {

	public:
		int height;
		int width;
		unsigned char **pixels;
		double min_x;
		double max_x;
		double min_y;
		double max_y;
	
		ImageSGI(int h, int w, double x1, double y1, double x2, double y2);
		ImageSGI(int h, int w);
		void write(char *filename);
		void reset();
		void add(double x, double y);
		void add(double x, double y, int color);
		void add(int x, int y, int color);
		void add(int x, int y);

		void verticalLine(double x, double y1, double y2, int color);
		void horizontalLine(double y, double x1, double x2, int color);

		void scale(int min);

	private:

		void putbyte(FILE *outf, unsigned char val);
		void putshort(FILE *outf, unsigned short val);
		int putlong(FILE *outf, unsigned long val);
		int hashI(double);
		int hashJ(double);     

};

#endif
