#include "Shape.h"

//******************************************************************
// Default constructor.
//******************************************************************
Shape::Shape():lowerLeftCorner(0,0), width(0), height(0), type(-1) {}

//******************************************************************
// Constructor.
//******************************************************************
Shape::Shape(int name): lowerLeftCorner(0,0), width(0), height(0), 
type(name) {}

//******************************************************************
// Constructor.
//******************************************************************
Shape::Shape(Point xy, double w, double h, int name): 
lowerLeftCorner(xy), width(w), height(h), type(name) {}  

//******************************************************************
// Copy constructor
//******************************************************************
Shape::Shape(const Shape & S) 
{ 	width = S.getWidth(); height = S.getHeight();
	type = S.getType(); 
	lowerLeftCorner = S.getCornerPoint(); 
}




//******************************************************************
// overloaded "=" operator
//******************************************************************
Shape & Shape::operator = (const Shape & S)
{
	// A check to make sure we're not trying to copy ourself to
	// ourself. If this did happen, then we would delete all
	// information before we had a chance to copy it.
	if(this == &S)
		return *this;
		
 	width = S.getWidth(); 
	height = S.getHeight();
	type = S.getType(); 
	lowerLeftCorner = S.getCornerPoint(); 
	
	return (*this);
}


//******************************************************************
//  overloaded ostream operator (standard output)
//******************************************************************
ostream & operator << ( ostream & str, const Shape & s)
{
	str << "corner = " << s.lowerLeftCorner;  

	return str;
}	


//******************************************************************
// overloaded ofstream operator (file output)
//******************************************************************
ofstream & operator << ( ofstream & fStr, const Shape & s)
{
	fStr << s.lowerLeftCorner;
	return fStr;
}	



//******************************************************************
// returns the type of shape.
//******************************************************************
char * Shape::getType(int i) const
{	
	switch (type)
	{
		case BOX:
			return "Box\n";
			break;
		case CYLINDER:
			return "Cylinder\n";
			break;
		default:
			return "error\n";
			break;
	}
}


	
