#include "Slave.h"

Slave::Slave(int rank, int nr, int sr, int debug)
{
	if (debug>1)
		DEBUG = 1;
	else
		DEBUG = 0;

	mpi_link = new SlaveMPI(rank, nr, sr, debug);

	if (DEBUG)
		printf("New slave created, rank=%d  north_rank=%d south_rank=%d\n", rank, nr, sr);

}

void Slave::loop()
{
	int bye = 0;
	int command;

	while (!bye)
	{
		// wait for a command from master and then act on it

		command = mpi_link->getCommand();

		switch (command) {
			case BYE:
				break;

			case SHUTDOWN:
				if (DEBUG) cout << "Slave recv'd a shutdown command" << endl;
				bye = 1;
				break;
			case STATS:
				if (DEBUG) cout << "Slave recv'd a stats update command" << endl;
				mpi_link->runStats();
				break;
			case RUNSIM:
				if (DEBUG) cout << "Slave recv'd a runsim command" << endl;

				// initSim now returns 1 if this processor
				// needs to run the simulation, 0 if we have
				// too many processors and we should just wait around

				if (mpi_link->initSim())
				{
					if (DEBUG) cout << "Slave is going into main sim loop" << endl;
					mpi_link->simLoop();
				}
				break;
		}
	}
}
