#ifndef SLAVEWORLD_HPP
#define SLAVEWORLD_HPP

#include <math.h>
#include <stdlib.h>
#include <assert.h>
#include "Shape.h"
#include "SlaveGrid.h"
#include "Parameter.h"
#include "Cylinder.h"
#include "Box.h"
#include "Timer.h"

class SlaveWorld {
	public:
		SlaveGrid * theGrid;
		Parameter param;
		long timeSteps;			// this is our main timer
		
		SlaveWorld(int sy, int ey, int maxpts, int maxshapes);
		~SlaveWorld();

		void createWorld();
		void firstLoop(int rank);	// used for first loop of simulation
		void nextLoop(int rank);	// used for all other loops
		void setGlobalID(long id);	// set the globalID
		
	private:
		int startY, endY;		// start and end rows of our grid
		int maxPts, maxShapePts;
		long globalID;			// tracks unique ID for new particles
};

#endif
